/* 
	   With this plugin, you can show some advertisement or rules to the players. 

	   *** The main folder is AMXX configs DIR ***

	   Default Motds dir is "addons/amxmodx/configs/motd";
	you can change it by #define MOTD_FOLDER to other string
	The plugin will read the dir for Motds 
	Max support for MAX_MOTD_SUPPORT (default 5) motd files.
	If you want to change this,just #define MAX_MOTD_SUPPORT to another number.
	In each Motd,only the first 1,200 characters are effective,(not include '0' - newline)
	
	    Default Motd Header config file is "addons/amxmodx/configs/motd_header.cfg"
	Also, you can change it by #define MOTD_HEADER_CONFIG to other string.
	Add Advanced Motd's headers to this file. Form the second line,one line one title!
	If a motd has no header,will use the server name instead.
	
	Motd files can be HTML formatted with VGUI2.
	A Motd will showed when a player dies every <five or ...> rounds.
	
	  v1.2 changed Log:
	  
		fixed a bug when reloadmotd.(last time,forgot to reset max_motd zero,^_^)
	  
	  v1.1 changed Log:
	  
		change MOTD folder dir
		can define MOTD_FOLDER and MOTD_HEADER_CONFIG
		load MOTD files and config file using file handle
		fixed bugs in read file content function

	
	  Cvars: 
	
	amx_advancedmotd ,default 1; 	disable to show motd to the players,set it to 0
	amx_showmotdeveryrounds	,default 5; 	Set how many rounds to show one motd when dying.
*/

#include <amxmodx>
#include <amxmisc>

#define PLUGIN "Advanced Motd"
#define VERSION "1.2"
#define AUTHOR "KinSprite"

#define MAX_MOTD_SUPPORT 5
#define MOTD_FOLDER "motd"
#define MOTD_HEADER_CONFIG "motd_header.cfg"

new g_advancedmotd
new g_showmotdeveryrounds
new motd[MAX_MOTD_SUPPORT][1200]
new motd_header[MAX_MOTD_SUPPORT][32]
new max_motd
new bool:motd_showed[33] = false
new round_counter
new showmotd_counter[33]

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	register_concmd("amx_reloadmotd","cmd_reloadmotd",ADMIN_IMMUNITY," - reload Advanced Motd")
	g_advancedmotd = register_cvar("amx_advancedmotd","1")
	g_showmotdeveryrounds = register_cvar("amx_showmotdeveryrounds","5")
	set_task(1.2,"load_motd")
	register_logevent("startnewround",2,"0=World triggered","1=Round_Start")
	register_event("DeathMsg", "show_Advmotd","a")
	return PLUGIN_CONTINUE
}

public client_putinserver(id)
{
	motd_showed[id]=true
	showmotd_counter[id]=0
	return PLUGIN_CONTINUE
}

public load_motd()
{
	if(get_pcvar_num(g_advancedmotd)!=1)
		return PLUGIN_CONTINUE
	new cfg_path[128]
	get_configsdir(cfg_path,127)
	new motd_path[160]
	format(motd_path,159,"%s/%s",cfg_path,MOTD_FOLDER)
	new path[64]
	new handle = open_dir(motd_path,path,63)
	if(handle!=0)
	{
		new buff[MAX_MOTD_SUPPORT+2][64]
		new i
		for(i=0;i<MAX_MOTD_SUPPORT+2;i++)
		{
			if(next_file(handle, buff[i], 63))
				max_motd++	
			else
				continue	
		}
		close_dir(handle)
		max_motd--		// include parent dir,so max_motd -1
		new path_name[256]
		for(i=0;i<max_motd;i++)
		{
			format(path_name,255,"%s/%s",motd_path,buff[i+1])
			read_motdfile(path_name,motd[i])
		}
	}
	for(new i=1;i<33;i++)
		showmotd_counter[i] = 0
	set_task(0.2,"load_motd_header")
	return PLUGIN_HANDLED
}

// read motd file into memory; not nead to read file again every show motd.
stock read_motdfile(filename[],out_text[])
{
	new handle = fopen(filename,"rt")
	if(handle!=0)
	{
		new line_len = file_size(filename,1)
		new text_buff[1200],buffer[1024]
		new line
		for(;line<line_len;line++)
		{
			fgets(handle, buffer, 1023)
			add(text_buff,1199,buffer)
		}
		fclose(handle)
		copy(out_text,1199,text_buff)
	}
}

public load_motd_header()
{
	new cfg_path[128]
	get_configsdir(cfg_path,127)
	new motd_header_path[256]
	format(motd_header_path,255,"%s/%s",cfg_path,MOTD_HEADER_CONFIG)
	new handle = fopen(motd_header_path,"rt")
	if(handle!=0)
	{
		new line_len = file_size(motd_header_path,1)
		new buffer[256]
		new line
		for(;line<line_len&&line<=max_motd;line++)
		{
			fgets(handle, buffer, 255)
			if(line!=0)
				format(motd_header[line-1],31,buffer)
		}
		fclose(handle)
	}
	return PLUGIN_HANDLED
}

public cmd_reloadmotd(id,level,cid)
{
	if (!cmd_access(id, level, cid, 1))
		return PLUGIN_HANDLED
	if(get_pcvar_num(g_advancedmotd)!=1)
		console_print(id,"[AMXX] *** Sorry.Advanced Motd isn't allowed in this server.Cvar ^"amx_advancedmotd^" is off !")	
	else {
		console_print(id,"[AMXX] *** Will reload Advanced Motd now .")
		max_motd = 0
		set_task(0.5,"load_motd")
	}
	return PLUGIN_HANDLED
}

public startnewround()
{
	if(round_counter+1<get_pcvar_num(g_showmotdeveryrounds))
		round_counter++
	else {
		round_counter=0
		new players[32],num,i
		get_players(players,num)
		for(i=0;i<num;i++)
			motd_showed[players[i]] = false
	}
}

public show_Advmotd()
{
	if(get_pcvar_num(g_advancedmotd)!=1||max_motd==0)
		return PLUGIN_HANDLED
	new player = read_data(2)
	if(is_user_bot(player))
		return PLUGIN_HANDLED
	if(!motd_showed[player])
	{
		new param[2]
		param[0]=player
		set_task(1.2,"client_show_motd",5532+player,param,1)
	}	
	return PLUGIN_HANDLED
}

public client_show_motd(param[])
{	
	new counter = showmotd_counter[param[0]]
	if(!equali(motd_header[counter],""))
		show_motd(param[0],motd[counter],motd_header[counter])
	else
		show_motd(param[0],motd[counter])
	motd_showed[param[0]] = true
	if(counter<max_motd-1)
		showmotd_counter[param[0]]++
	else showmotd_counter[param[0]]=0
}